import sys
sys.path.append("../")
sys.path.append("../../")
from ffc.compiler.compiler import *

name = "MyPDE"

a = None
L = None
    
dx = Integral("interior")
ds = Integral("boundary")

i = Index()
j = Index()
k = Index()
l = Index()
m = Index()
n = Index()

// This file was automatically generated by FFC, the FEniCS Form Compiler.
// Licensed under the GNU GPL Version 2.

#ifndef __NAVIERSTOKES_H
#define __NAVIERSTOKES_H

#include <dolfin/NewFiniteElement.h>
#include <dolfin/LinearForm.h>
#include <dolfin/BilinearForm.h>

namespace dolfin { namespace NavierStokes {

/// This is the finite element for which the form is generated,
/// providing the information neccessary to do assembly.

class FiniteElement : public dolfin::NewFiniteElement
{
public:

  FiniteElement() : dolfin::NewFiniteElement(), tensordims(0)
  {
    tensordims = new unsigned int [1];
    tensordims[0] = 3;
  }

  ~FiniteElement()
  {
    if ( tensordims ) delete [] tensordims;
  }

  inline unsigned int spacedim() const
  {
    return 12;
  }

  inline unsigned int shapedim() const
  {
    return 3;
  }

  inline unsigned int tensordim(unsigned int i) const
  {
    dolfin_assert(i < 1);
    return tensordims[i];
  }

  inline unsigned int rank() const
  {
    return 1;
  }

  // FIXME: Only works for nodal basis
  inline unsigned int dof(unsigned int i, const Cell& cell, const Mesh& mesh) const
  {
    return (i/4) * mesh.noNodes() + cell.nodeID(i % 4);
  }

  // FIXME: Only works for nodal basis
  inline const Point coord(unsigned int i, const Cell& cell, const Mesh& mesh) const
  {
    return cell.node(i % 4).coord();
  }

private:

  unsigned int* tensordims;

};

/// This class contains the form to be evaluated, including
/// contributions from the interior and boundary of the domain.

class BilinearForm : public dolfin::BilinearForm
{
public:

  BilinearForm(const NewFunction& w0) : dolfin::BilinearForm()
  {
    // Add functions
    init(1, 12);
    add(w0);
  }

  bool interior(real* block) const
  {
    // Compute geometry tensors
    real G0_000 = det*c[0][0]*g00;
    real G0_001 = det*c[0][0]*g10;
    real G0_002 = det*c[0][0]*g20;
    real G0_010 = det*c[0][1]*g00;
    real G0_011 = det*c[0][1]*g10;
    real G0_012 = det*c[0][1]*g20;
    real G0_020 = det*c[0][2]*g00;
    real G0_021 = det*c[0][2]*g10;
    real G0_022 = det*c[0][2]*g20;
    real G0_030 = det*c[0][3]*g00;
    real G0_031 = det*c[0][3]*g10;
    real G0_032 = det*c[0][3]*g20;
    real G0_040 = det*c[0][4]*g00;
    real G0_041 = det*c[0][4]*g10;
    real G0_042 = det*c[0][4]*g20;
    real G0_050 = det*c[0][5]*g00;
    real G0_051 = det*c[0][5]*g10;
    real G0_052 = det*c[0][5]*g20;
    real G0_060 = det*c[0][6]*g00;
    real G0_061 = det*c[0][6]*g10;
    real G0_062 = det*c[0][6]*g20;
    real G0_070 = det*c[0][7]*g00;
    real G0_071 = det*c[0][7]*g10;
    real G0_072 = det*c[0][7]*g20;
    real G0_080 = det*c[0][8]*g00;
    real G0_081 = det*c[0][8]*g10;
    real G0_082 = det*c[0][8]*g20;
    real G0_090 = det*c[0][9]*g00;
    real G0_091 = det*c[0][9]*g10;
    real G0_092 = det*c[0][9]*g20;
    real G0_0100 = det*c[0][10]*g00;
    real G0_0101 = det*c[0][10]*g10;
    real G0_0102 = det*c[0][10]*g20;
    real G0_0110 = det*c[0][11]*g00;
    real G0_0111 = det*c[0][11]*g10;
    real G0_0112 = det*c[0][11]*g20;
    real G0_100 = det*c[0][0]*g01;
    real G0_101 = det*c[0][0]*g11;
    real G0_102 = det*c[0][0]*g21;
    real G0_110 = det*c[0][1]*g01;
    real G0_111 = det*c[0][1]*g11;
    real G0_112 = det*c[0][1]*g21;
    real G0_120 = det*c[0][2]*g01;
    real G0_121 = det*c[0][2]*g11;
    real G0_122 = det*c[0][2]*g21;
    real G0_130 = det*c[0][3]*g01;
    real G0_131 = det*c[0][3]*g11;
    real G0_132 = det*c[0][3]*g21;
    real G0_140 = det*c[0][4]*g01;
    real G0_141 = det*c[0][4]*g11;
    real G0_142 = det*c[0][4]*g21;
    real G0_150 = det*c[0][5]*g01;
    real G0_151 = det*c[0][5]*g11;
    real G0_152 = det*c[0][5]*g21;
    real G0_160 = det*c[0][6]*g01;
    real G0_161 = det*c[0][6]*g11;
    real G0_162 = det*c[0][6]*g21;
    real G0_170 = det*c[0][7]*g01;
    real G0_171 = det*c[0][7]*g11;
    real G0_172 = det*c[0][7]*g21;
    real G0_180 = det*c[0][8]*g01;
    real G0_181 = det*c[0][8]*g11;
    real G0_182 = det*c[0][8]*g21;
    real G0_190 = det*c[0][9]*g01;
    real G0_191 = det*c[0][9]*g11;
    real G0_192 = det*c[0][9]*g21;
    real G0_1100 = det*c[0][10]*g01;
    real G0_1101 = det*c[0][10]*g11;
    real G0_1102 = det*c[0][10]*g21;
    real G0_1110 = det*c[0][11]*g01;
    real G0_1111 = det*c[0][11]*g11;
    real G0_1112 = det*c[0][11]*g21;
    real G0_200 = det*c[0][0]*g02;
    real G0_201 = det*c[0][0]*g12;
    real G0_202 = det*c[0][0]*g22;
    real G0_210 = det*c[0][1]*g02;
    real G0_211 = det*c[0][1]*g12;
    real G0_212 = det*c[0][1]*g22;
    real G0_220 = det*c[0][2]*g02;
    real G0_221 = det*c[0][2]*g12;
    real G0_222 = det*c[0][2]*g22;
    real G0_230 = det*c[0][3]*g02;
    real G0_231 = det*c[0][3]*g12;
    real G0_232 = det*c[0][3]*g22;
    real G0_240 = det*c[0][4]*g02;
    real G0_241 = det*c[0][4]*g12;
    real G0_242 = det*c[0][4]*g22;
    real G0_250 = det*c[0][5]*g02;
    real G0_251 = det*c[0][5]*g12;
    real G0_252 = det*c[0][5]*g22;
    real G0_260 = det*c[0][6]*g02;
    real G0_261 = det*c[0][6]*g12;
    real G0_262 = det*c[0][6]*g22;
    real G0_270 = det*c[0][7]*g02;
    real G0_271 = det*c[0][7]*g12;
    real G0_272 = det*c[0][7]*g22;
    real G0_280 = det*c[0][8]*g02;
    real G0_281 = det*c[0][8]*g12;
    real G0_282 = det*c[0][8]*g22;
    real G0_290 = det*c[0][9]*g02;
    real G0_291 = det*c[0][9]*g12;
    real G0_292 = det*c[0][9]*g22;
    real G0_2100 = det*c[0][10]*g02;
    real G0_2101 = det*c[0][10]*g12;
    real G0_2102 = det*c[0][10]*g22;
    real G0_2110 = det*c[0][11]*g02;
    real G0_2111 = det*c[0][11]*g12;
    real G0_2112 = det*c[0][11]*g22;

    // Compute element tensor
    block[0] = -0.0166666666667*G0_000 - 0.0166666666667*G0_001 - 0.0166666666667*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.0166666666667*G0_140 - 0.0166666666667*G0_141 - 0.0166666666667*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.0166666666667*G0_280 - 0.0166666666667*G0_281 - 0.0166666666667*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[1] = 0.0166666666667*G0_000 + 0.00833333333333*G0_010 + 0.00833333333333*G0_020 + 0.00833333333333*G0_030 + 0.0166666666667*G0_140 + 0.00833333333333*G0_150 + 0.00833333333333*G0_160 + 0.00833333333333*G0_170 + 0.0166666666667*G0_280 + 0.00833333333333*G0_290 + 0.00833333333333*G0_2100 + 0.00833333333333*G0_2110;
    block[2] = 0.0166666666667*G0_001 + 0.00833333333333*G0_011 + 0.00833333333333*G0_021 + 0.00833333333333*G0_031 + 0.0166666666667*G0_141 + 0.00833333333333*G0_151 + 0.00833333333333*G0_161 + 0.00833333333333*G0_171 + 0.0166666666667*G0_281 + 0.00833333333333*G0_291 + 0.00833333333333*G0_2101 + 0.00833333333333*G0_2111;
    block[3] = 0.0166666666667*G0_002 + 0.00833333333333*G0_012 + 0.00833333333333*G0_022 + 0.00833333333333*G0_032 + 0.0166666666667*G0_142 + 0.00833333333333*G0_152 + 0.00833333333333*G0_162 + 0.00833333333333*G0_172 + 0.0166666666667*G0_282 + 0.00833333333333*G0_292 + 0.00833333333333*G0_2102 + 0.00833333333333*G0_2112;
    block[4] = 0.0;
    block[5] = 0.0;
    block[6] = 0.0;
    block[7] = 0.0;
    block[8] = 0.0;
    block[9] = 0.0;
    block[10] = 0.0;
    block[11] = 0.0;
    block[12] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.0166666666667*G0_010 - 0.0166666666667*G0_011 - 0.0166666666667*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.0166666666667*G0_150 - 0.0166666666667*G0_151 - 0.0166666666667*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.0166666666667*G0_290 - 0.0166666666667*G0_291 - 0.0166666666667*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[13] = 0.00833333333333*G0_000 + 0.0166666666667*G0_010 + 0.00833333333333*G0_020 + 0.00833333333333*G0_030 + 0.00833333333333*G0_140 + 0.0166666666667*G0_150 + 0.00833333333333*G0_160 + 0.00833333333333*G0_170 + 0.00833333333333*G0_280 + 0.0166666666667*G0_290 + 0.00833333333333*G0_2100 + 0.00833333333333*G0_2110;
    block[14] = 0.00833333333333*G0_001 + 0.0166666666667*G0_011 + 0.00833333333333*G0_021 + 0.00833333333333*G0_031 + 0.00833333333333*G0_141 + 0.0166666666667*G0_151 + 0.00833333333333*G0_161 + 0.00833333333333*G0_171 + 0.00833333333333*G0_281 + 0.0166666666667*G0_291 + 0.00833333333333*G0_2101 + 0.00833333333333*G0_2111;
    block[15] = 0.00833333333333*G0_002 + 0.0166666666667*G0_012 + 0.00833333333333*G0_022 + 0.00833333333333*G0_032 + 0.00833333333333*G0_142 + 0.0166666666667*G0_152 + 0.00833333333333*G0_162 + 0.00833333333333*G0_172 + 0.00833333333333*G0_282 + 0.0166666666667*G0_292 + 0.00833333333333*G0_2102 + 0.00833333333333*G0_2112;
    block[16] = 0.0;
    block[17] = 0.0;
    block[18] = 0.0;
    block[19] = 0.0;
    block[20] = 0.0;
    block[21] = 0.0;
    block[22] = 0.0;
    block[23] = 0.0;
    block[24] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.0166666666667*G0_020 - 0.0166666666667*G0_021 - 0.0166666666667*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.0166666666667*G0_160 - 0.0166666666667*G0_161 - 0.0166666666667*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.0166666666667*G0_2100 - 0.0166666666667*G0_2101 - 0.0166666666667*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[25] = 0.00833333333333*G0_000 + 0.00833333333333*G0_010 + 0.0166666666667*G0_020 + 0.00833333333333*G0_030 + 0.00833333333333*G0_140 + 0.00833333333333*G0_150 + 0.0166666666667*G0_160 + 0.00833333333333*G0_170 + 0.00833333333333*G0_280 + 0.00833333333333*G0_290 + 0.0166666666667*G0_2100 + 0.00833333333333*G0_2110;
    block[26] = 0.00833333333333*G0_001 + 0.00833333333333*G0_011 + 0.0166666666667*G0_021 + 0.00833333333333*G0_031 + 0.00833333333333*G0_141 + 0.00833333333333*G0_151 + 0.0166666666667*G0_161 + 0.00833333333333*G0_171 + 0.00833333333333*G0_281 + 0.00833333333333*G0_291 + 0.0166666666667*G0_2101 + 0.00833333333333*G0_2111;
    block[27] = 0.00833333333333*G0_002 + 0.00833333333333*G0_012 + 0.0166666666667*G0_022 + 0.00833333333333*G0_032 + 0.00833333333333*G0_142 + 0.00833333333333*G0_152 + 0.0166666666667*G0_162 + 0.00833333333333*G0_172 + 0.00833333333333*G0_282 + 0.00833333333333*G0_292 + 0.0166666666667*G0_2102 + 0.00833333333333*G0_2112;
    block[28] = 0.0;
    block[29] = 0.0;
    block[30] = 0.0;
    block[31] = 0.0;
    block[32] = 0.0;
    block[33] = 0.0;
    block[34] = 0.0;
    block[35] = 0.0;
    block[36] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.0166666666667*G0_030 - 0.0166666666667*G0_031 - 0.0166666666667*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.0166666666667*G0_170 - 0.0166666666667*G0_171 - 0.0166666666667*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.0166666666667*G0_2110 - 0.0166666666667*G0_2111 - 0.0166666666667*G0_2112;
    block[37] = 0.00833333333333*G0_000 + 0.00833333333333*G0_010 + 0.00833333333333*G0_020 + 0.0166666666667*G0_030 + 0.00833333333333*G0_140 + 0.00833333333333*G0_150 + 0.00833333333333*G0_160 + 0.0166666666667*G0_170 + 0.00833333333333*G0_280 + 0.00833333333333*G0_290 + 0.00833333333333*G0_2100 + 0.0166666666667*G0_2110;
    block[38] = 0.00833333333333*G0_001 + 0.00833333333333*G0_011 + 0.00833333333333*G0_021 + 0.0166666666667*G0_031 + 0.00833333333333*G0_141 + 0.00833333333333*G0_151 + 0.00833333333333*G0_161 + 0.0166666666667*G0_171 + 0.00833333333333*G0_281 + 0.00833333333333*G0_291 + 0.00833333333333*G0_2101 + 0.0166666666667*G0_2111;
    block[39] = 0.00833333333333*G0_002 + 0.00833333333333*G0_012 + 0.00833333333333*G0_022 + 0.0166666666667*G0_032 + 0.00833333333333*G0_142 + 0.00833333333333*G0_152 + 0.00833333333333*G0_162 + 0.0166666666667*G0_172 + 0.00833333333333*G0_282 + 0.00833333333333*G0_292 + 0.00833333333333*G0_2102 + 0.0166666666667*G0_2112;
    block[40] = 0.0;
    block[41] = 0.0;
    block[42] = 0.0;
    block[43] = 0.0;
    block[44] = 0.0;
    block[45] = 0.0;
    block[46] = 0.0;
    block[47] = 0.0;
    block[48] = 0.0;
    block[49] = 0.0;
    block[50] = 0.0;
    block[51] = 0.0;
    block[52] = -0.0166666666667*G0_000 - 0.0166666666667*G0_001 - 0.0166666666667*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.0166666666667*G0_140 - 0.0166666666667*G0_141 - 0.0166666666667*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.0166666666667*G0_280 - 0.0166666666667*G0_281 - 0.0166666666667*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[53] = 0.0166666666667*G0_000 + 0.00833333333333*G0_010 + 0.00833333333333*G0_020 + 0.00833333333333*G0_030 + 0.0166666666667*G0_140 + 0.00833333333333*G0_150 + 0.00833333333333*G0_160 + 0.00833333333333*G0_170 + 0.0166666666667*G0_280 + 0.00833333333333*G0_290 + 0.00833333333333*G0_2100 + 0.00833333333333*G0_2110;
    block[54] = 0.0166666666667*G0_001 + 0.00833333333333*G0_011 + 0.00833333333333*G0_021 + 0.00833333333333*G0_031 + 0.0166666666667*G0_141 + 0.00833333333333*G0_151 + 0.00833333333333*G0_161 + 0.00833333333333*G0_171 + 0.0166666666667*G0_281 + 0.00833333333333*G0_291 + 0.00833333333333*G0_2101 + 0.00833333333333*G0_2111;
    block[55] = 0.0166666666667*G0_002 + 0.00833333333333*G0_012 + 0.00833333333333*G0_022 + 0.00833333333333*G0_032 + 0.0166666666667*G0_142 + 0.00833333333333*G0_152 + 0.00833333333333*G0_162 + 0.00833333333333*G0_172 + 0.0166666666667*G0_282 + 0.00833333333333*G0_292 + 0.00833333333333*G0_2102 + 0.00833333333333*G0_2112;
    block[56] = 0.0;
    block[57] = 0.0;
    block[58] = 0.0;
    block[59] = 0.0;
    block[60] = 0.0;
    block[61] = 0.0;
    block[62] = 0.0;
    block[63] = 0.0;
    block[64] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.0166666666667*G0_010 - 0.0166666666667*G0_011 - 0.0166666666667*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.0166666666667*G0_150 - 0.0166666666667*G0_151 - 0.0166666666667*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.0166666666667*G0_290 - 0.0166666666667*G0_291 - 0.0166666666667*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[65] = 0.00833333333333*G0_000 + 0.0166666666667*G0_010 + 0.00833333333333*G0_020 + 0.00833333333333*G0_030 + 0.00833333333333*G0_140 + 0.0166666666667*G0_150 + 0.00833333333333*G0_160 + 0.00833333333333*G0_170 + 0.00833333333333*G0_280 + 0.0166666666667*G0_290 + 0.00833333333333*G0_2100 + 0.00833333333333*G0_2110;
    block[66] = 0.00833333333333*G0_001 + 0.0166666666667*G0_011 + 0.00833333333333*G0_021 + 0.00833333333333*G0_031 + 0.00833333333333*G0_141 + 0.0166666666667*G0_151 + 0.00833333333333*G0_161 + 0.00833333333333*G0_171 + 0.00833333333333*G0_281 + 0.0166666666667*G0_291 + 0.00833333333333*G0_2101 + 0.00833333333333*G0_2111;
    block[67] = 0.00833333333333*G0_002 + 0.0166666666667*G0_012 + 0.00833333333333*G0_022 + 0.00833333333333*G0_032 + 0.00833333333333*G0_142 + 0.0166666666667*G0_152 + 0.00833333333333*G0_162 + 0.00833333333333*G0_172 + 0.00833333333333*G0_282 + 0.0166666666667*G0_292 + 0.00833333333333*G0_2102 + 0.00833333333333*G0_2112;
    block[68] = 0.0;
    block[69] = 0.0;
    block[70] = 0.0;
    block[71] = 0.0;
    block[72] = 0.0;
    block[73] = 0.0;
    block[74] = 0.0;
    block[75] = 0.0;
    block[76] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.0166666666667*G0_020 - 0.0166666666667*G0_021 - 0.0166666666667*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.0166666666667*G0_160 - 0.0166666666667*G0_161 - 0.0166666666667*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.0166666666667*G0_2100 - 0.0166666666667*G0_2101 - 0.0166666666667*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[77] = 0.00833333333333*G0_000 + 0.00833333333333*G0_010 + 0.0166666666667*G0_020 + 0.00833333333333*G0_030 + 0.00833333333333*G0_140 + 0.00833333333333*G0_150 + 0.0166666666667*G0_160 + 0.00833333333333*G0_170 + 0.00833333333333*G0_280 + 0.00833333333333*G0_290 + 0.0166666666667*G0_2100 + 0.00833333333333*G0_2110;
    block[78] = 0.00833333333333*G0_001 + 0.00833333333333*G0_011 + 0.0166666666667*G0_021 + 0.00833333333333*G0_031 + 0.00833333333333*G0_141 + 0.00833333333333*G0_151 + 0.0166666666667*G0_161 + 0.00833333333333*G0_171 + 0.00833333333333*G0_281 + 0.00833333333333*G0_291 + 0.0166666666667*G0_2101 + 0.00833333333333*G0_2111;
    block[79] = 0.00833333333333*G0_002 + 0.00833333333333*G0_012 + 0.0166666666667*G0_022 + 0.00833333333333*G0_032 + 0.00833333333333*G0_142 + 0.00833333333333*G0_152 + 0.0166666666667*G0_162 + 0.00833333333333*G0_172 + 0.00833333333333*G0_282 + 0.00833333333333*G0_292 + 0.0166666666667*G0_2102 + 0.00833333333333*G0_2112;
    block[80] = 0.0;
    block[81] = 0.0;
    block[82] = 0.0;
    block[83] = 0.0;
    block[84] = 0.0;
    block[85] = 0.0;
    block[86] = 0.0;
    block[87] = 0.0;
    block[88] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.0166666666667*G0_030 - 0.0166666666667*G0_031 - 0.0166666666667*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.0166666666667*G0_170 - 0.0166666666667*G0_171 - 0.0166666666667*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.0166666666667*G0_2110 - 0.0166666666667*G0_2111 - 0.0166666666667*G0_2112;
    block[89] = 0.00833333333333*G0_000 + 0.00833333333333*G0_010 + 0.00833333333333*G0_020 + 0.0166666666667*G0_030 + 0.00833333333333*G0_140 + 0.00833333333333*G0_150 + 0.00833333333333*G0_160 + 0.0166666666667*G0_170 + 0.00833333333333*G0_280 + 0.00833333333333*G0_290 + 0.00833333333333*G0_2100 + 0.0166666666667*G0_2110;
    block[90] = 0.00833333333333*G0_001 + 0.00833333333333*G0_011 + 0.00833333333333*G0_021 + 0.0166666666667*G0_031 + 0.00833333333333*G0_141 + 0.00833333333333*G0_151 + 0.00833333333333*G0_161 + 0.0166666666667*G0_171 + 0.00833333333333*G0_281 + 0.00833333333333*G0_291 + 0.00833333333333*G0_2101 + 0.0166666666667*G0_2111;
    block[91] = 0.00833333333333*G0_002 + 0.00833333333333*G0_012 + 0.00833333333333*G0_022 + 0.0166666666667*G0_032 + 0.00833333333333*G0_142 + 0.00833333333333*G0_152 + 0.00833333333333*G0_162 + 0.0166666666667*G0_172 + 0.00833333333333*G0_282 + 0.00833333333333*G0_292 + 0.00833333333333*G0_2102 + 0.0166666666667*G0_2112;
    block[92] = 0.0;
    block[93] = 0.0;
    block[94] = 0.0;
    block[95] = 0.0;
    block[96] = 0.0;
    block[97] = 0.0;
    block[98] = 0.0;
    block[99] = 0.0;
    block[100] = 0.0;
    block[101] = 0.0;
    block[102] = 0.0;
    block[103] = 0.0;
    block[104] = -0.0166666666667*G0_000 - 0.0166666666667*G0_001 - 0.0166666666667*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.0166666666667*G0_140 - 0.0166666666667*G0_141 - 0.0166666666667*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.0166666666667*G0_280 - 0.0166666666667*G0_281 - 0.0166666666667*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[105] = 0.0166666666667*G0_000 + 0.00833333333333*G0_010 + 0.00833333333333*G0_020 + 0.00833333333333*G0_030 + 0.0166666666667*G0_140 + 0.00833333333333*G0_150 + 0.00833333333333*G0_160 + 0.00833333333333*G0_170 + 0.0166666666667*G0_280 + 0.00833333333333*G0_290 + 0.00833333333333*G0_2100 + 0.00833333333333*G0_2110;
    block[106] = 0.0166666666667*G0_001 + 0.00833333333333*G0_011 + 0.00833333333333*G0_021 + 0.00833333333333*G0_031 + 0.0166666666667*G0_141 + 0.00833333333333*G0_151 + 0.00833333333333*G0_161 + 0.00833333333333*G0_171 + 0.0166666666667*G0_281 + 0.00833333333333*G0_291 + 0.00833333333333*G0_2101 + 0.00833333333333*G0_2111;
    block[107] = 0.0166666666667*G0_002 + 0.00833333333333*G0_012 + 0.00833333333333*G0_022 + 0.00833333333333*G0_032 + 0.0166666666667*G0_142 + 0.00833333333333*G0_152 + 0.00833333333333*G0_162 + 0.00833333333333*G0_172 + 0.0166666666667*G0_282 + 0.00833333333333*G0_292 + 0.00833333333333*G0_2102 + 0.00833333333333*G0_2112;
    block[108] = 0.0;
    block[109] = 0.0;
    block[110] = 0.0;
    block[111] = 0.0;
    block[112] = 0.0;
    block[113] = 0.0;
    block[114] = 0.0;
    block[115] = 0.0;
    block[116] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.0166666666667*G0_010 - 0.0166666666667*G0_011 - 0.0166666666667*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.0166666666667*G0_150 - 0.0166666666667*G0_151 - 0.0166666666667*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.0166666666667*G0_290 - 0.0166666666667*G0_291 - 0.0166666666667*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[117] = 0.00833333333333*G0_000 + 0.0166666666667*G0_010 + 0.00833333333333*G0_020 + 0.00833333333333*G0_030 + 0.00833333333333*G0_140 + 0.0166666666667*G0_150 + 0.00833333333333*G0_160 + 0.00833333333333*G0_170 + 0.00833333333333*G0_280 + 0.0166666666667*G0_290 + 0.00833333333333*G0_2100 + 0.00833333333333*G0_2110;
    block[118] = 0.00833333333333*G0_001 + 0.0166666666667*G0_011 + 0.00833333333333*G0_021 + 0.00833333333333*G0_031 + 0.00833333333333*G0_141 + 0.0166666666667*G0_151 + 0.00833333333333*G0_161 + 0.00833333333333*G0_171 + 0.00833333333333*G0_281 + 0.0166666666667*G0_291 + 0.00833333333333*G0_2101 + 0.00833333333333*G0_2111;
    block[119] = 0.00833333333333*G0_002 + 0.0166666666667*G0_012 + 0.00833333333333*G0_022 + 0.00833333333333*G0_032 + 0.00833333333333*G0_142 + 0.0166666666667*G0_152 + 0.00833333333333*G0_162 + 0.00833333333333*G0_172 + 0.00833333333333*G0_282 + 0.0166666666667*G0_292 + 0.00833333333333*G0_2102 + 0.00833333333333*G0_2112;
    block[120] = 0.0;
    block[121] = 0.0;
    block[122] = 0.0;
    block[123] = 0.0;
    block[124] = 0.0;
    block[125] = 0.0;
    block[126] = 0.0;
    block[127] = 0.0;
    block[128] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.0166666666667*G0_020 - 0.0166666666667*G0_021 - 0.0166666666667*G0_022 - 0.00833333333333*G0_030 - 0.00833333333333*G0_031 - 0.00833333333333*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.0166666666667*G0_160 - 0.0166666666667*G0_161 - 0.0166666666667*G0_162 - 0.00833333333333*G0_170 - 0.00833333333333*G0_171 - 0.00833333333333*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.0166666666667*G0_2100 - 0.0166666666667*G0_2101 - 0.0166666666667*G0_2102 - 0.00833333333333*G0_2110 - 0.00833333333333*G0_2111 - 0.00833333333333*G0_2112;
    block[129] = 0.00833333333333*G0_000 + 0.00833333333333*G0_010 + 0.0166666666667*G0_020 + 0.00833333333333*G0_030 + 0.00833333333333*G0_140 + 0.00833333333333*G0_150 + 0.0166666666667*G0_160 + 0.00833333333333*G0_170 + 0.00833333333333*G0_280 + 0.00833333333333*G0_290 + 0.0166666666667*G0_2100 + 0.00833333333333*G0_2110;
    block[130] = 0.00833333333333*G0_001 + 0.00833333333333*G0_011 + 0.0166666666667*G0_021 + 0.00833333333333*G0_031 + 0.00833333333333*G0_141 + 0.00833333333333*G0_151 + 0.0166666666667*G0_161 + 0.00833333333333*G0_171 + 0.00833333333333*G0_281 + 0.00833333333333*G0_291 + 0.0166666666667*G0_2101 + 0.00833333333333*G0_2111;
    block[131] = 0.00833333333333*G0_002 + 0.00833333333333*G0_012 + 0.0166666666667*G0_022 + 0.00833333333333*G0_032 + 0.00833333333333*G0_142 + 0.00833333333333*G0_152 + 0.0166666666667*G0_162 + 0.00833333333333*G0_172 + 0.00833333333333*G0_282 + 0.00833333333333*G0_292 + 0.0166666666667*G0_2102 + 0.00833333333333*G0_2112;
    block[132] = 0.0;
    block[133] = 0.0;
    block[134] = 0.0;
    block[135] = 0.0;
    block[136] = 0.0;
    block[137] = 0.0;
    block[138] = 0.0;
    block[139] = 0.0;
    block[140] = -0.00833333333333*G0_000 - 0.00833333333333*G0_001 - 0.00833333333333*G0_002 - 0.00833333333333*G0_010 - 0.00833333333333*G0_011 - 0.00833333333333*G0_012 - 0.00833333333333*G0_020 - 0.00833333333333*G0_021 - 0.00833333333333*G0_022 - 0.0166666666667*G0_030 - 0.0166666666667*G0_031 - 0.0166666666667*G0_032 - 0.00833333333333*G0_140 - 0.00833333333333*G0_141 - 0.00833333333333*G0_142 - 0.00833333333333*G0_150 - 0.00833333333333*G0_151 - 0.00833333333333*G0_152 - 0.00833333333333*G0_160 - 0.00833333333333*G0_161 - 0.00833333333333*G0_162 - 0.0166666666667*G0_170 - 0.0166666666667*G0_171 - 0.0166666666667*G0_172 - 0.00833333333333*G0_280 - 0.00833333333333*G0_281 - 0.00833333333333*G0_282 - 0.00833333333333*G0_290 - 0.00833333333333*G0_291 - 0.00833333333333*G0_292 - 0.00833333333333*G0_2100 - 0.00833333333333*G0_2101 - 0.00833333333333*G0_2102 - 0.0166666666667*G0_2110 - 0.0166666666667*G0_2111 - 0.0166666666667*G0_2112;
    block[141] = 0.00833333333333*G0_000 + 0.00833333333333*G0_010 + 0.00833333333333*G0_020 + 0.0166666666667*G0_030 + 0.00833333333333*G0_140 + 0.00833333333333*G0_150 + 0.00833333333333*G0_160 + 0.0166666666667*G0_170 + 0.00833333333333*G0_280 + 0.00833333333333*G0_290 + 0.00833333333333*G0_2100 + 0.0166666666667*G0_2110;
    block[142] = 0.00833333333333*G0_001 + 0.00833333333333*G0_011 + 0.00833333333333*G0_021 + 0.0166666666667*G0_031 + 0.00833333333333*G0_141 + 0.00833333333333*G0_151 + 0.00833333333333*G0_161 + 0.0166666666667*G0_171 + 0.00833333333333*G0_281 + 0.00833333333333*G0_291 + 0.00833333333333*G0_2101 + 0.0166666666667*G0_2111;
    block[143] = 0.00833333333333*G0_002 + 0.00833333333333*G0_012 + 0.00833333333333*G0_022 + 0.0166666666667*G0_032 + 0.00833333333333*G0_142 + 0.00833333333333*G0_152 + 0.00833333333333*G0_162 + 0.0166666666667*G0_172 + 0.00833333333333*G0_282 + 0.00833333333333*G0_292 + 0.00833333333333*G0_2102 + 0.0166666666667*G0_2112;

    return true;
  }

};


} }

#endif

compile([a, L], name, "")
